//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * サウンド能力ヘッダ
 * @author Junpee
 */

#ifndef SOUND_CAPACITY_H_
#define SOUND_CAPACITY_H_

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * サウンド能力
 */
class SoundCapacity{
friend class LampSound;
public:
	//--------------------------------------------------------------------------
	/**
	 * 更新
	 * @return 成功すればtrue
	 */
	virtual bool refresh();

	//--------------------------------------------------------------------------
	/**
	 * Microsoft認定ドライバか
	 * @return Microsoft認定ドライバならtrue
	 */
	virtual bool isCertifiedDriver() const{
		return ((capacity_.dwFlags & DSCAPS_CERTIFIED) != 0);
	}

	/**
	 * 連続的な周波数設定をサポートしているか
	 * @return 連続的な周波数設定をサポートしているならtrue
	 */
	virtual bool isSupportedContinuousRate() const{
		return ((capacity_.dwFlags & DSCAPS_CONTINUOUSRATE) != 0);
	}

	/**
	 * エミュレートドライバか
	 * @return エミュレートドライバならtrue
	 */
	virtual bool isEmulatedDriver() const{
		return ((capacity_.dwFlags & DSCAPS_EMULDRIVER) != 0);
	}

	//--------------------------------------------------------------------------
	/**
	 * 16bitプライマリバッファをサポートするか
	 * @return 16bitプライマリバッファをサポートするならtrue
	 */
	virtual bool isSupported16bitPrimaryBuffer() const{
		return ((capacity_.dwFlags & DSCAPS_PRIMARY16BIT) != 0);
	}

	/**
	 * 8bitプライマリバッファをサポートするか
	 * @return 8bitプライマリバッファをサポートするならtrue
	 */
	virtual bool isSupported8bitPrimaryBuffer() const{
		return ((capacity_.dwFlags & DSCAPS_PRIMARY8BIT) != 0);
	}

	/**
	 * モノラルプライマリバッファをサポートするか
	 * @return モノラルプライマリバッファをサポートするならtrue
	 */
	virtual bool isSupportedMonauralPrimaryBuffer() const{
		return ((capacity_.dwFlags & DSCAPS_PRIMARYMONO) != 0);
	}

	/**
	 * ステレオプライマリバッファをサポートするか
	 * @return ステレオプライマリバッファをサポートするならtrue
	 */
	virtual bool isSupportedStereoPrimaryBuffer() const{
		return ((capacity_.dwFlags & DSCAPS_PRIMARYSTEREO) != 0);
	}

	//--------------------------------------------------------------------------
	/**
	 * 16bitセカンダリバッファをサポートするか
	 * @return 16bitセカンダリバッファをサポートするならtrue
	 */
	virtual bool isSupported16bitSecondaryBuffer() const{
		return ((capacity_.dwFlags & DSCAPS_SECONDARY16BIT) != 0);
	}

	/**
	 * 8bitセカンダリバッファをサポートするか
	 * @return 8bitセカンダリバッファをサポートするならtrue
	 */
	virtual bool isSupported8bitSecondaryBuffer() const{
		return ((capacity_.dwFlags & DSCAPS_SECONDARY8BIT) != 0);
	}

	/**
	 * モノラルセカンダリバッファをサポートするか
	 * @return モノラルセカンダリバッファをサポートするならtrue
	 */
	virtual bool isSupportedMonauralSecondaryBuffer() const{
		return ((capacity_.dwFlags & DSCAPS_SECONDARYMONO) != 0);
	}

	/**
	 * ステレオセカンダリバッファをサポートするか
	 * @return ステレオセカンダリバッファをサポートするならtrue
	 */
	virtual bool isSupportedStereoSecondaryBuffer() const{
		return ((capacity_.dwFlags & DSCAPS_SECONDARYSTEREO) != 0);
	}

	//--------------------------------------------------------------------------
	/**
	 * セカンダリの最大サンプリングレート取得
	 * @return セカンダリの最大サンプリングレート
	 */
	virtual u_int getMaxSecondarySampleRate() const{
		return capacity_.dwMaxSecondarySampleRate;
	}

	/**
	 * セカンダリの最小サンプリングレート取得
	 * @return セカンダリの最小サンプリングレート
	 */
	virtual u_int getMinSecondarySampleRate() const{
		return capacity_.dwMinSecondarySampleRate;
	}

	//--------------------------------------------------------------------------
	/**
	 * 文字列への変換
	 * @return 文字列
	 */
	virtual String toString() const;

private:
	//--------------------------------------------------------------------------
	/**
	 * コンストラクタ
	 */
	SoundCapacity();

	/**
	 * デストラクタ
	 */
	virtual ~SoundCapacity();

	/**
	 * 初期化
	 * @param directSound DirectSound
	 * @return 成功すればtrue
	 */
	virtual bool initialize(DirectSound* directSound);

	/**
	 * 能力チェック
	 * @return 能力があればtrue
	 */
	virtual bool checkCapacity();

	// bool文字列取得
	String getBoolString(bool flag) const{
		if(flag){ return "○"; }
		else{ return "×"; }
	}

	//--------------------------------------------------------------------------
	// コピーコンストラクタの隠蔽
	SoundCapacity(const SoundCapacity& copy);

	// 代入コピーの隠蔽
	void operator =(const SoundCapacity& copy);

	//--------------------------------------------------------------------------
	// DirectSound
	DirectSound* directSound_;
	// 能力
	DSCAPS capacity_;

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of SOUND_CAPACITY_H_
//------------------------------------------------------------------------------
